.386
.model flat, stdcall
option casemap:none

; -------------------------------------------------------------------------

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\odbc32.inc
include \masm32\include\comctl32.inc
include \masm32\include\user32.inc

includelib \masm32\lib\odbc32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

; -------------------------------------------------------------------------

CompareFunc         proto    :DWORD, :DWORD, :DWORD
DlgProc             proto    :DWORD, :DWORD, :DWORD, :DWORD
NumberFixUp         proto    :DWORD, :DWORD
ODBCConnect         proto    :DWORD
ODBCDisconnect      proto    :DWORD
QueryProc           proto    :DWORD, :DWORD, :DWORD, :DWORD
RunQuery            proto    :DWORD
SwitchMenuState     proto    :DWORD
UpdatelParam        proto

; -------------------------------------------------------------------------

.const

IDD_MAINDLG         equ 101
IDR_MAINMENU        equ 102
IDC_DATALIST        equ 1000
IDM_CONNECT         equ 40001
IDM_DISCONNECT      equ 40002
IDM_QUERY           equ 40003
IDC_NAME            equ 1000
IDC_OK              equ 1001
IDC_CANCEL          equ 1002
IDM_CUSTOMQUERY     equ 40004
IDD_QUERYDLG        equ 102

ColCustName         equ 0
ColCustContact      equ 1
ColCustTelno        equ 2

CompareNumeric      equ 1
CompareString       equ 2

SortAscend          equ 0
SortDescend         equ 1

.data

AppName             db "ODBC Test", 0

ServerName          db "Firebird Server", 0
UserName            db "SYSDBA", 0 
Authentic           db "masterkey", 0

SQLStatement        db "select * from CUSTOMER", 0
WhereStatement      db " where CONTACT_LAST=?", 0

Heading1            db "Customer", 0
Heading2            db "Contact", 0
Heading3            db "Telephone No.", 0

ConnectCaption      db "Complete Connection String", 0
Disconnect          db "Disconnect successful", 0
AllocEnvFail        db "Environment handle allocation failed", 0
AllocConnFail       db "Connection handle allocation failed", 0
SetAttrFail         db "Cannot set desired ODBC version", 0
NoData              db "You must type the name in the edit box", 0
ExecuteFail         db "Execution of SQL statement failed", 0
ConnFail            db "Connection attempt failed", 0
AllocStmtFail       db "Statement handle allocation failed", 0

.data?

hConn               dd ?    ; connection handle
hEnv                dd ?    ; environment handle
hStmt               dd ?    ; statement handle

hInstance           dd ?    ; instance handle
hMenu               dd ?    ; handle to the main menu
hList               dd ?    ; handle to the listview control -- SysListView32

StringLen           dd ?
CustLength          dd ?
ContactLength       dd ?
TelNoLength         dd ?

Conn                db 256 dup(?)
Customer            db 26 dup(?)
ContactLast         db 26 dup(?)
TelNo               db 21 dup(?)
SearchName          db 26 dup(?)
ConnectString       db 1024 dup(?)
BufferTelNo         db 26 dup(?)
ColumnFlags         db 20 dup(?)

; -------------------------------------------------------------------------

.code

start:
    invoke GetModuleHandle, NULL
    mov hInstance, eax

    invoke DialogBoxParam, hInstance, IDD_MAINDLG, 0, ADDR DlgProc, 0
    invoke ExitProcess, eax

    invoke InitCommonControls

; -------------------------------------------------------------------------

DlgProc proc hDlg :DWORD, uMsg :DWORD, wParam :DWORD, lParam :DWORD

LOCAL    ClkdColumn :BYTE
LOCAL    SortDir    :BYTE
LOCAL    DataType   :BYTE     
LOCAL    Column     :BYTE
LOCAL    SortSpecs  :DWORD

    .if uMsg==WM_INITDIALOG
    
        invoke GetMenu, hDlg
        mov hMenu, eax
        
        invoke GetDlgItem, hDlg, IDC_DATALIST
        mov hList, eax
        
        call InsertColumn
        
            ; initialize sort specs in ColumnFlags: direction and data type
            ; listview columns sort direction initialized in bit-0 to 0
            ; initialize column data type flags, using bits-1:3
        
        mov al, CompareString
        shl al, 1
        mov ColumnFlags[ColCustName], al         ; customer name
        
        mov al, CompareString
        shl al, 1
        mov ColumnFlags[ColCustContact], al      ; contact last name
        
        mov al, CompareNumeric
        shl al, 1
        mov ColumnFlags[ColCustTelno], al        ; customer tel no
        
    .elseif uMsg==WM_COMMAND
        .if lParam==0
            mov eax, wParam

            .if ax==IDM_CONNECT
                invoke ODBCConnect, hDlg

            .elseif ax==IDM_DISCONNECT
                invoke ODBCDisconnect, hDlg

            .elseif ax==IDM_QUERY
                invoke RunQuery, hDlg

            .elseif ax==IDM_CUSTOMQUERY
                invoke DialogBoxParam, hInstance, IDD_QUERYDLG, hDlg, ADDR QueryProc, 0
                .elseif ax==WM_CLOSE
                    invoke GetMenuState, hMenu, IDM_CONNECT, MF_BYCOMMAND
                    .if eax==MF_GRAYED
                        invoke ODBCDisconnect, hDlg
                    .endif
                    invoke DestroyWindow, hDlg
            .endif
        .endif

    .elseif uMsg==WM_NOTIFY

        push edi
        mov edi,lParam

        assume edi:ptr NMHDR

        mov eax,[edi].hwndFrom ; handle of control sending message

        .if eax==hList

            .if [edi].code == LVN_COLUMNCLICK

                assume edi:ptr NM_LISTVIEW    

                mov eax, [edi].iSubItem  ; <<<< iSubItem points to clicked column
                mov ClkdColumn, al
                
                push esi
                
                mov si, ax                 ; set index into ColumnFlags array
                mov al, ColumnFlags[si]    ; get sortdir and datatype flags
                mov dh, al                 ; keep copy
                xor al, 1                  ; reset the sortdir to its opposite
                mov ColumnFlags[si], al    ; put it back into array
                mov dl, ClkdColumn         ; get the column clicked
                shl dl, 4                  ; multiply by 16 to fit in high 4 bits
                or dh, dl                  ; put them together
                movzx eax, dh              ; set up for putting into the dword
                mov SortSpecs, eax         ; put into sort specifications
                
                pop esi
                    
                invoke SendMessage, hList,    ; perform the sort now
                                    LVM_SORTITEMS, 
                                    SortSpecs, 
                                    ADDR CompareFunc
                                                    
                invoke UpdatelParam       ; reinitialize the listview for next time
            .endif

        .endif
        
        pop edi

    .else
        mov eax, FALSE
        ret
    .endif
    mov eax, TRUE
    ret
DlgProc endp    

; -------------------------------------------------------------------------

UpdatelParam proc uses edi

    LOCAL lvi:LV_ITEM

    invoke SendMessage, hList, LVM_GETITEMCOUNT, 0, 0
    mov edi, eax
    
    mov lvi.imask,    LVIF_PARAM
    mov lvi.iSubItem, 0
    mov lvi.iItem,    0

    .while edi > 0

        push lvi.iItem
        pop lvi.lParam

        invoke SendMessage, hList, LVM_SETITEM, 0, addr lvi

        inc lvi.iItem
        dec edi

    .endw

    ret

UpdatelParam endp

; -------------------------------------------------------------------------

SwitchMenuState proc Flag :DWORD
    .if Flag==TRUE 
        invoke EnableMenuItem, hMenu, IDM_CONNECT, MF_GRAYED
        invoke EnableMenuItem, hMenu, IDM_DISCONNECT, MF_ENABLED
        invoke EnableMenuItem, hMenu, IDM_QUERY, MF_ENABLED
        invoke EnableMenuItem, hMenu, IDM_CUSTOMQUERY, MF_ENABLED
    .else
        invoke EnableMenuItem, hMenu, IDM_CONNECT, MF_ENABLED
        invoke EnableMenuItem, hMenu, IDM_DISCONNECT, MF_GRAYED
        invoke EnableMenuItem, hMenu, IDM_QUERY, MF_GRAYED
        invoke EnableMenuItem, hMenu, IDM_CUSTOMQUERY, MF_GRAYED
    .endif
    ret
SwitchMenuState endp

; -------------------------------------------------------------------------

ODBCConnect proc hDlg :DWORD
    invoke SQLAllocHandle, SQL_HANDLE_ENV, SQL_NULL_HANDLE, ADDR hEnv
    
    .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
        invoke SQLSetEnvAttr, hEnv, SQL_ATTR_ODBC_VERSION, SQL_OV_ODBC3, 0
        
        .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
            invoke SQLAllocHandle, SQL_HANDLE_DBC, hEnv, ADDR hConn
            
            .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
                                ;
                                ; note: I kept looking for a handle for the actual
                                ; logon with SQLConnect, but there isn't one;
                                ; presumably the actual logon is tied into the 
                                ; hConn behind the scenes by the ODBC manager
                                ;
                invoke SQLConnect, hConn, 
                                        ADDR ServerName, SQL_NTS, 
                                        ADDR UserName, SQL_NTS, 
                                        ADDR Authentic, SQL_NTS
                                        
                .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
                    invoke SwitchMenuState, TRUE
                .else
                    invoke MessageBox, hDlg, ADDR ConnFail, ADDR AppName, MB_OK+MB_ICONERROR
                    invoke SQLFreeHandle, SQL_HANDLE_DBC, hConn
                    invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
                .endif
            .else
                invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
                invoke MessageBox, hDlg, ADDR AllocConnFail, ADDR AppName, \
                                        MB_OK+MB_ICONERROR
            .endif
        .else
            invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
            invoke MessageBox, hDlg, ADDR SetAttrFail, ADDR AppName, \
                                            MB_OK+MB_ICONERROR
        .endif
    .else
        invoke MessageBox, hDlg, ADDR AllocEnvFail, ADDR AppName, \
                                        MB_OK+MB_ICONERROR    
    .endif
    ret
ODBCConnect endp

; -------------------------------------------------------------------------

ODBCDisconnect proc hDlg :DWORD
    invoke SQLDisconnect, hConn
    invoke SQLFreeHandle, SQL_HANDLE_DBC, hConn
    invoke SQLFreeHandle, SQL_HANDLE_ENV, hEnv
    invoke SwitchMenuState, FALSE
    invoke ShowWindow, hList, SW_HIDE
    ret
ODBCDisconnect endp

; -------------------------------------------------------------------------

InsertColumn proc
    LOCAL lvc:LV_COLUMN

    mov lvc.imask, LVCF_TEXT+LVCF_WIDTH+LVCF_FMT

    mov lvc.lx, 150
    mov lvc.pszText, offset Heading1
    mov lvc.fmt, LVCFMT_LEFT
    invoke SendMessage, hList, LVM_INSERTCOLUMN, ColCustName, ADDR lvc

    mov lvc.lx, 120
    mov lvc.pszText, offset Heading2
    mov lvc.fmt, LVCFMT_LEFT
    invoke SendMessage, hList, LVM_INSERTCOLUMN, ColCustContact, ADDR lvc    

    mov lvc.lx, 90
    mov lvc.pszText, offset Heading3
    mov lvc.fmt, LVCFMT_RIGHT
    invoke SendMessage, hList, LVM_INSERTCOLUMN, ColCustTelno, ADDR lvc

    ret        
InsertColumn endp

; -------------------------------------------------------------------------

FillData proc

    LOCAL lvi    :LV_ITEM
    LOCAL row    :DWORD
    LOCAL cnt    :DWORD

    invoke SQLBindCol, hStmt, 2, SQL_C_CHAR, ADDR Customer, \
                                    sizeof Customer, ADDR CustLength
    invoke SQLBindCol, hStmt, 4, SQL_C_CHAR, ADDR ContactLast, \
                                    sizeof ContactLast, ADDR ContactLength
    invoke SQLBindCol, hStmt, 5, SQL_C_CHAR, ADDR TelNo, \
                                    sizeof TelNo, ADDR TelNoLength

    mov row, 0
    mov cnt, 0

    .while TRUE
        mov byte ptr ds:[Customer], 0
        mov byte ptr ds:[ContactLast], 0
        mov byte ptr ds:[TelNo], 0

        invoke SQLFetch, hStmt

        .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
            mov lvi.imask, LVIF_TEXT+LVIF_PARAM

            push row
            pop lvi.iItem    
            mov lvi.imask, LVIF_TEXT

            mov lvi.iSubItem, 0
            mov lvi.pszText, offset Customer
            invoke SendMessage, hList, LVM_INSERTITEM, 0, ADDR lvi

            inc lvi.iSubItem
            mov lvi.pszText, offset ContactLast
            invoke SendMessage, hList, LVM_SETITEM, 0, ADDR lvi

            inc lvi.iSubItem
            mov lvi.pszText, offset TelNo
            invoke SendMessage, hList, LVM_SETITEM, 0, ADDR lvi

            inc row
            
        .else
            .break
        .endif
    .endw
    ret
FillData endp

; -------------------------------------------------------------------------

RunQuery proc hDlg :DWORD
    invoke ShowWindow, hList, SW_SHOW
    invoke SendMessage, hList, LVM_DELETEALLITEMS, 0, 0

    invoke SQLAllocHandle, SQL_HANDLE_STMT, hConn, ADDR hStmt

    .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
        invoke SQLExecDirect, hStmt, ADDR SQLStatement, sizeof SQLStatement
        
        .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
            invoke FillData
        .else
            invoke ShowWindow, hList, SW_HIDE
            invoke MessageBox, hDlg, ADDR ExecuteFail, ADDR AppName, \
                                                MB_OK+MB_ICONERROR
        .endif
        invoke SQLCloseCursor, hStmt
        invoke SQLFreeHandle, SQL_HANDLE_STMT, hStmt
    .else
        invoke ShowWindow, hList, SW_HIDE
        invoke MessageBox, hDlg, ADDR AllocStmtFail, ADDR AppName, MB_OK+MB_ICONERROR
    .endif
    ret
RunQuery endp

; -------------------------------------------------------------------------

QueryProc proc hDlg :DWORD, uMsg :DWORD, wParam :DWORD, lParam :DWORD    

    .if uMsg==WM_INITDIALOG
        invoke ShowWindow, hList, SW_SHOW ; this is in main dialog box!

        invoke SQLAllocHandle, SQL_HANDLE_STMT, hConn, ADDR hStmt

        .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
            invoke lstrcpy, ADDR Conn, ADDR SQLStatement
            invoke lstrcat, ADDR Conn, ADDR WhereStatement

            invoke SQLBindParameter, hStmt, 1, SQL_PARAM_INPUT, \
                                            SQL_C_CHAR, SQL_CHAR, 25, 0, \
                                            ADDR SearchName, 25, ADDR StringLen

            invoke SQLPrepare, hStmt, ADDR Conn, sizeof Conn
        .else
            invoke ShowWindow, hList, SW_HIDE

            invoke MessageBox, hDlg, ADDR AllocStmtFail, ADDR AppName, \
                                                    MB_OK+MB_ICONERROR
                                                    
            invoke EndDialog, hDlg, 0
        .endif    
    .elseif uMsg==WM_COMMAND
        mov eax, wParam
        shr eax, 16

        .if ax==BN_CLICKED
            mov eax, wParam

            .if ax==IDC_OK
                invoke GetDlgItemText, hDlg, IDC_NAME, ADDR SearchName, 25
                .if ax==0
                    invoke MessageBox, hDlg, ADDR NoData, ADDR AppName, \
                                                    MB_OK+MB_ICONERROR
                                                    
                    invoke GetDlgItem, hDlg, IDC_NAME
                    invoke SetFocus, eax
                .else
                                ;note that the query dialog stays open while the
                                ; listview in the main dialog displays the data
                    invoke lstrlen, ADDR SearchName
                    mov StringLen, eax

                    ;note that if this statement is commented out, the
                                ; listview will insert the returned data above
                                ; the previous row; it does not prevent duplicates
                                ; however
                    invoke SendMessage, hList, LVM_DELETEALLITEMS, 0, 0

                    invoke SQLExecute, hStmt
                    invoke FillData
                    invoke SQLCloseCursor, hStmt

                .endif
            .else
                    invoke SQLFreeHandle, SQL_HANDLE_STMT, hStmt
                    invoke ShowWindow, hList, SW_HIDE
                    invoke EndDialog, hDlg, 0
            .endif
        .endif

    .else

        mov eax, FALSE
        ret
    .endif

    mov eax, TRUE
    ret
QueryProc endp

;    --------------------------------------------------------
;  this function does a special fixup of numbers
;        to be used in comparison/sorting operations;
;        telephone numbers (incl. international) can come in 
;        all sorts of layouts, with embedded spaces, hyphens, 
;        and parens; all of the non-numeric characters need to 
;        be stripped out so there is nothing left but numeric 
;        digits
;
;    note: this function can be generalized as a number cleanup
;        tool; not only will it remove any of the non-digits, but
;        while doing so, it will trim left and right blanks
;
;    added a return value of the number of digits in the return string
;    --------------------------------------------------------
;        example use:
;        invoke NumberFixUp, ADDR destTelNo, ADDR sourceTelNo

; ########################################################################

NumberFixUp proc dest :DWORD, source :DWORD
    LOCAL CharCnt:DWORD
    
    push esi
    push edi

    mov esi, source
    mov edi, dest
    
    mov CharCnt, 0

    cld                ; read forward

    @@:
        lodsb
        cmp al, 0      ; exit on zero
        je ltOut_Label
        
        cmp al, 48     ; loop if less than '0'
        jb @B
        
        cmp al, 57     ; loop if greater than '9'
        ja @B
        
        stosb          ; store the byte
        inc CharCnt

        jmp @B         ; go back around

    ltOut_Label:
        stosb          ; write terminating zero

    pop edi
    pop esi

    mov eax, CharCnt
    ret

NumberFixUp endp

; 

CompareFunc proc uses edi lParam1:DWORD, lParam2:DWORD, SortType:DWORD
;
; **************************************
;        lParam1        row number withing the chosen column
;        lParam2        ditto -- the comparison value
;        SortType       a flag from the calling routine, arbitrary
;
;        note: there is no direction flag passed into this routine
; **************************************

LOCAL    buffer[256]:BYTE
LOCAL    buffer1[256]:BYTE
LOCAL    buffer2[256]:BYTE
LOCAL    SortDir:BYTE
LOCAL    DataType:BYTE     
LOCAL    Column:BYTE     
LOCAL    dColumn:DWORD     
    
LOCAL lvi:LV_ITEM

    mov eax, SortType
    mov dl, al
    and dl, 1
    mov SortDir, dl
    
    mov dl, al
    shr dl, 1
    and dl, 7
    mov DataType, dl
    
    shr al, 4
    mov Column, al
    
    movzx eax, Column
    mov dColumn, eax

    mov lvi.imask, LVIF_TEXT
    lea eax, buffer ; all the SendMessage calls use buffer through lvi
    mov lvi.pszText, eax
    mov lvi.cchTextMax, 256

        ;    note: the documentation says that the iSubItem
        ;    in the LV_ITEM sent with LVM_GETITEMTEXT requires
        ;    that columns are specified on a one-based count,
        ;    rather than zero; Iczelion's listview.asm uses a 0 and
        ;    fetches the data from the zeroeth column, so the doc
        ;    is obviously not correct; documentation suggests 0 will
        ;    receive the item label rather than row contents
        
    push dColumn
    pop lvi.iSubItem ; send 0-based column number

    .if DataType == CompareNumeric

        invoke SendMessage, hList, LVM_GETITEMTEXT, lParam1, addr lvi
        invoke NumberFixUp, addr buffer1, addr buffer

        invoke SendMessage, hList, LVM_GETITEMTEXT, lParam2, addr lvi
        invoke NumberFixUp, addr buffer2, addr buffer
        
        .if SortDir == SortAscend
            invoke lstrcmp, addr buffer1,addr buffer2
        .else ; SortDescend
            invoke lstrcmp, addr buffer2, addr buffer1
        .endif
            
    .elseif DataType == CompareString

        invoke SendMessage, hList, LVM_GETITEMTEXT, lParam1, addr lvi
        invoke lstrcpy, addr buffer1, addr buffer
        
        invoke SendMessage, hList, LVM_GETITEMTEXT, lParam2, addr lvi
        invoke lstrcpy, addr buffer2, addr buffer        
            
        .if SortDir == SortAscend
            invoke lstrcmpi, addr buffer1,addr buffer2
        .else ; SortDescend
            invoke lstrcmpi, addr buffer2, addr buffer1
        .endif
        
    .else
    
        mov eax, 0 ; unknown datatype so return a "don't care" result

    .endif
    
    ret

CompareFunc endp
    
end start